(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('https://cdn.jsdelivr.net/npm/nodemod@latest/dist/lib/parse5.min.js')) :
    typeof define === 'function' && define.amd ? define(['exports', 'https://cdn.jsdelivr.net/npm/nodemod@latest/dist/lib/parse5.min.js'], factory) :
    (global = global || self, factory(global.LitNtml = {}, global.parse5_min_js));
}(this, (function (exports, parse5_min_js) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }

    function processLiteralsSync(strings) {
        var exps = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            exps[_i - 1] = arguments[_i];
        }
        var done = exps.map(function (n) {
            return (Array.isArray(n) ? n : [n]).map(function (o) { return 'function' === typeof (o) ? o() : o; });
        });
        var doneLen = done.length;
        return strings.reduce(function (p, n, i) {
            var nTask = done[i];
            var joined = Array.isArray(nTask) ? nTask.join('') : nTask;
            return "" + p + (i >= doneLen ? n : "" + n + joined);
        }, '');
    }

    function parseLiteralsSync(serializeFn) {
        return function (fn, strings) {
            var exps = [];
            for (var _i = 2; _i < arguments.length; _i++) {
                exps[_i - 2] = arguments[_i];
            }
            var content = processLiteralsSync.apply(void 0, __spreadArrays([strings], exps));
            return serializeFn(fn(content));
        };
    }

    function processLiterals(strings) {
        var exps = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            exps[_i - 1] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var listTask, done, doneLen;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        listTask = exps.map(function (n) { return __awaiter(_this, void 0, void 0, function () {
                            var tasks;
                            var _this = this;
                            return __generator(this, function (_a) {
                                tasks = (Array.isArray(n) ? n : [n])
                                    .map(function (o) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                    return [2, 'function' === typeof (o) ? o() : o];
                                }); }); });
                                return [2, Promise.all(tasks)];
                            });
                        }); });
                        return [4, Promise.all(listTask)];
                    case 1:
                        done = _a.sent();
                        doneLen = done.length;
                        return [2, strings.reduce(function (p, n, i) {
                                var nTask = done[i];
                                var joined = Array.isArray(nTask) ? nTask.join('') : nTask;
                                return "" + p + (i >= doneLen ? n : "" + n + joined);
                            }, '')];
                }
            });
        });
    }

    function parseLiterals(serializeFn) {
        var _this = this;
        return function (fn, strings) {
            var exps = [];
            for (var _i = 2; _i < arguments.length; _i++) {
                exps[_i - 2] = arguments[_i];
            }
            return __awaiter(_this, void 0, void 0, function () {
                var content;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4, processLiterals.apply(void 0, __spreadArrays([strings], exps))];
                        case 1:
                            content = _a.sent();
                            return [2, serializeFn(fn(content))];
                    }
                });
            });
        };
    }

    var parser = parseLiterals(parse5_min_js.serialize);
    var parserSync = parseLiteralsSync(parse5_min_js.serialize);
    var html = function (s) {
        var e = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            e[_i - 1] = arguments[_i];
        }
        return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2, parser.apply(void 0, __spreadArrays([function (c) { return parse5_min_js.parse("<!doctype html>" + c); }, s], e))];
        }); });
    };
    var htmlFragment = function (s) {
        var e = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            e[_i - 1] = arguments[_i];
        }
        return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2, parser.apply(void 0, __spreadArrays([parse5_min_js.parseFragment, s], e))];
        }); });
    };
    var htmlSync = function (s) {
        var e = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            e[_i - 1] = arguments[_i];
        }
        return parserSync.apply(void 0, __spreadArrays([function (c) { return parse5_min_js.parse("<!doctype html>" + c); }, s], e));
    };
    var htmlFragmentSync = function (s) {
        var e = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            e[_i - 1] = arguments[_i];
        }
        return parserSync.apply(void 0, __spreadArrays([parse5_min_js.parseFragment, s], e));
    };
    var litNtml = {
        html: html,
        htmlFragment: htmlFragment,
        htmlFragmentSync: htmlFragmentSync,
        htmlSync: htmlSync,
    };

    exports.default = litNtml;
    exports.html = html;
    exports.htmlFragment = htmlFragment;
    exports.htmlFragmentSync = htmlFragmentSync;
    exports.htmlSync = htmlSync;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=lit-ntml.umd.js.map
